		TITLE	EXTENDED SCREEN AND KEYBOARD CONTROL DRIVER
		PAGE	60,132
CODE		SEGMENT BYTE PUBLIC 'CODE'
		ASSUME	CS:CODE,DS:CODE,ES:CODE
;-----------------------------------------------------------------------;
;									;
;		PROGRAM 	ANSI.SYS (EXTENDED KEYBOARD AND SCREEN	;
;					  CONTROL DRIVER)		;
;									;
;		VERSION 	DOS 2.0 DEVICE DRIVER			;
;									;
;		DESCRIPTION	THIS DEVICE DRIVER WAS DESIGNED SO THAT ;
;				SPECIAL CHARACTER SEQUENCES COULD BE	;
;				ISSUED FROM WITHIN A PROGRAM TO CONTROL ;
;				SCREEN FUNCTIONS SUCH AS POSITION, MODE,;
;				ETC. YOU CAN ALSO REASSIGN THE MEANING	;
;				OF ANY KEY ON THE KEYBOARD TO ANOTHER	;
;				CHARACTER OR SEQUENCE OF CHARACTERS.	;
;									;
;		COPYRIGHT	INTERNATIONAL BUSINESS MACHINES, IBM	;
;									;
;		DISASSEMBLED BY RANDY SPURLOCK				;
;									;
;		DATE		OCTOBER, 1983				;
;									;
;-----------------------------------------------------------------------;
		PAGE
;-----------------------------------------------------------------------;
;									;
;	INCLUDE BASIC INPUT/OUTPUT SYSTEM (BIOS) MACROS 		;
;									;
;-----------------------------------------------------------------------;
		%OUT		BIOS.MAC
		INCLUDE 	BIOS.MAC
;-----------------------------------------------------------------------;
;									;
;	INCLUDE BASIC INPUT/OUTPUT SYSTEM (BIOS) DATA EQUATES		;
;									;
;-----------------------------------------------------------------------;
		%OUT		BIOS.DAT
		INCLUDE 	BIOS.DAT
;-----------------------------------------------------------------------;
;									;
;	INCLUDE DISK OPERATING SYSTEM (DOS) STRUCTURES			;
;									;
;-----------------------------------------------------------------------;
		%OUT		DOS.STR
		INCLUDE 	DOS.STR
;-----------------------------------------------------------------------;
;									;
;	INCLUDE DISK OPERATING SYSTEM (DOS) EQUATES			;
;									;
;-----------------------------------------------------------------------;
		%OUT		DOS.EQU
		INCLUDE 	DOS.EQU
		PAGE
;-----------------------------------------------------------------------;
;									;
;	THE FOLLOWING STRUCTURES ARE DEFINED HERE:			;
;									;
;	NAME	SIZE (BYTES)	DESCRIPTION				;
;	----	----		-----------				;
;									;
;	COM	 3	COMMAND TABLE ENTRY STRUCTURE			;
;									;
;	REN	 3	GRAPHICS RENDITION TABLE ENTRY STRUCTURE	;
;									;
;	EXTENT	 4	EXTENDED CHARACTER TRANSLATION ENTRY STRUCTURE	;
;									;
;	REGENT	 3	REGULAR CHARACTER TRANSLATION ENTRY STRUCTURE	;
;									;
;-----------------------------------------------------------------------;
		%OUT	STRUCTURES
COM		STRUC			;COMMAND TABLE STRUCTURE
COM_CHR 	DB	" "             ;OVERRIDABLE COMMAND CHARACTER
COM_ADDRESS	DW	0		;OVERRIDABLE COMMAND ROUTINE ADDRESS
COM		ENDS			;END OF COM STRUCTURE
REN		STRUC			;GRAPHICS RENDITION TABLE STRUCTURE
MODE_NUM	DB	0		;GRAPHICS RENDITION MODE NUMBER
AND_MASK	DB	0		;ATTRIBUTE AND MASK
OR_MASK 	DB	0		;ATTRIBUTE OR MASK
REN		ENDS			;END OF REN STRUCTURE
EXTENT		STRUC			;EXT. CHARACTER TRANS. ENTRY STRUCTURE
		DB	0		;ENTRY SIZE
		DB	0		;FIRST HALF OF EXTENDED CHARACTER
		DB	0		;SECOND HALF OF EXTENDED CHARACTER
		DB	0		;REPLACEMENT CHARACTER
EXTENT		ENDS			;END OF EXTENT STRUCTURE
REGENT		STRUC			;REG. CHARACTER TRANS. ENTRY STRUCTURE
		DB	0		;ENTRY SIZE
		DB	0		;REGULAR CHARACTER
		DB	0		;REPLACEMENT CHARACTER
REGENT		ENDS			;END OF REGENT STRUCTURE
		PAGE
;-----------------------------------------------------------------------;
;									;
;	DEFINE ALL THE EQUATES USED BY THE PROGRAM			;
;									;
;-----------------------------------------------------------------------;
		%OUT	EQUATES
BUFF_HEAD	EQU	BYTE PTR 41AH	;OFFSET TO BIOS BUFFER HEAD POINTER
BUFF_TAIL	EQU	BYTE PTR 41CH	;OFFSET TO BIOS BUFFER TAIL POINTER
BUFF_PTR	EQU	1EH		;BIOS BUFFER POINTER BYTE
DATA		EQU	12H		;OFFSET TO OPERATION DATA IN HEADER
BUFF		EQU	0EH		;OFFSET TO BUFFER ADDRESS IN HEADER
CHAR		EQU	0DH		;OFFSET TO CHARACTER AREA IN HEADER
SET_MODE	EQU	00H		;BIOS VIDEO SET MODE OPTION
POSITION_CURSOR EQU	02H		;BIOS POSITION CURSOR OPTION
WRITE_CHAR	EQU	09H		;BIOS WRITE CHAR. & ATTR. OPTION
WRITE_TTY	EQU	0EH		;BIOS WRITE TTY OPTION
KEYBOARD_INPUT	EQU	00H		;BIOS KEYBOARD INPUT OPTION
INPUT_CHECK	EQU	01H		;BIOS LEYBOARD CHECK OPTION
OP_MAXIMUM	EQU	0BH		;MAXIMUM OPERATION CODE ALLOWED
BREAK		EQU	03H		;BREAK CHARACTER
ZERO		EQU	00H		;BINARY ZERO
ONE		EQU	01H		;BINARY ONE
TEN		EQU	0AH		;BIANRY TEN
BELL		EQU	07H		;ASCII BELL CHARACTER
BACK_SPACE	EQU	08H		;ASCII BACKSPACE CHARACTER
LF		EQU	0AH		;ASCII LINE FEED CHARACTER
CR		EQU	0DH		;ASCII CARRIAGE RETURN CHARACTER
ESC		EQU	1BH		;ASCII ESCAPE CHARACTER
SPACE		EQU	20H		;ASCII BLANK CHARACTER
DOUBLE_QUOTE	EQU	22H		;ASCII DOUBLE QUOTE CHARACTER
SINGLE_QUOTE	EQU	27H		;ASCII SINGLE QUOTE CHARACTER
SEMI_COLON	EQU	3BH		;ASCII SEMI-COLON CHARACTER
EQUAL_SIGN	EQU	3DH		;ASCII EQUAL SIGN CHARACTER
QUESTION_MARK	EQU	3FH		;ASCII QUESTION MARK CHARACTER
BRAKET		EQU	5BH		;ASCII LEFT BRACKET CHARACTER
ON		EQU	01H		;WRAP-AROUND MODE ON CONDITION
OFF		EQU	00H		;WRAP-AROUND MODE OFF CONDITION
NUM_ROW 	EQU	19H		;MAXIMUM NUMBER OF ROWS (25 ONE-BASED)
LAST_LINE	EQU	18H		;LAST LINE NUMBER (24 ZERO-BASED)
BW80		EQU	02H		;BLACK AND WHITE 80 COLUMN MODE
COLOR80 	EQU	03H		;COLOR 80 COLUMN MODE
COUNT_80	EQU	50H		;80 CHARACTER BYTE COUNT
SECOND		EQU	0A0H		;OFFSET OF SECOND SCREEN LINE
CHAR_COUNT	EQU	780H		;CHARACTER COUNT TO SCROLL
GRAPHICS	EQU	0B800H		;COLOR SCREEN MEMORY ADDRESS
MONO_CHROME	EQU	0B000H		;MONOCHROME SCREEN MEMORY ADDRESS
STATUS_PORT	EQU	3DAH		;6845 STATUS PORT NUMBER
MODE_PORT	EQU	3D8H		;6845 MODE PORT NUMBER
VER_RETRACE	EQU	08H		;VERTICAL RETRACE STATUS BIT
VIDEO_OFF	EQU	25H		;80 X 25 BUT NO VIDEO SIGNAL
VIDEO_ON	EQU	29H		;80 X 25 BUT WITH VIDEO SIGNAL
DATA_SEGMENT	EQU	40H		;BIOS DATA SEGMENT VALUE
MIN_NUM 	EQU	30H		;MINIMUM ASCII DIGIT
MAX_NUM 	EQU	39H		;MAXIMUM ASCII DIGIT
CONVERT 	EQU	30H		;ASCII TO BINARY CONVERSION VALUE
FIX		EQU	3030H		;BINARY TO ASCII FIX-UP VALUE
PLUS		EQU	01H		;INCREMENT VALUE
MIN_INC 	EQU	00FFH		;MINIMUM VALUE WITH INCREMENT
MAX_INC 	EQU	1801H		;MAXIMUM VALUE WITH INCREMENT
FORE_MASK	EQU	07H		;FOREGROUND COLOR BITS MASK
VIDEO_MASK	EQU	30H		;VIDEO BITS MASK
COM_SIZE	EQU	03H		;SIZE OF COMMAND TABLE ENTRY
REN_SIZE	EQU	03H		;SIZE OF GRAPHICS RENDITION TABLE ENTRY
MSG_LENGTH	EQU	09H		;CURSOR POSITION REPORT MESSAGE LENGTH
MAX_MODE	EQU	07H		;MAXIMUM MODE VALUE
MONO_MODE	EQU	07H		;MONO-CHROME MODE VALUE
MONO_BITS	EQU	30H		;MONO-CHROME BIT VALUE
SHIFT		EQU	04H		;SHIFT VALUE
EOT		EQU	0FFH		;END OF TABLE FLAG
SCROLL_WINDOW	EQU	0600H		;SCROLL ENTIRE WINDOW FUNCTION CODE
FORTY		EQU	10H		;FORTY COLUMN WIDTH BIT VALUE
HALF		EQU	27H		;NUMBER OF COLUMNS FOR 40 COLUMN MODE
VECTOR_1B	EQU	06CH		;INTERRUPT 1B VECTOR POINTER
VECTOR_29	EQU	0A4H		;INTERRUPT 29 VECTOR POINTER
MIN_PARM	EQU	03H		;MIN. NUMBER OF PARAM. FOR KKR ROUTINE
PARM_MAX	EQU	0C8H		;MAX. NUMBER OF PARAMETERS EVER (200)
		PAGE
;-----------------------------------------------------------------------;
;									;
;	START OF THE PROGRAM (DEVICE DRIVER HEADER)			;
;									;
;-----------------------------------------------------------------------;
		%OUT	DEVICE HEADER
HEADER		LABEL	NEAR		;START OF DEVICE HEADED TABLE
POINTER 	DD	0FFFFFFFFH	;POINTER TO NEXT DEVICE HEADER (NONE)
DEVICE_ATTR	DW	8013H		;DEVICE ATTRIBUTE
STRATEGY_PTR	DW	STRATEGY	;POINTER TO DEVICE STRAGETY ROUTINE
INTERRUPT_PTR	DW	INTERRUPT	;POINTER TO DEVICE INTERRUPT ROUTINE
DEVICE_NAME	DB	"CON     "
		%OUT	OPERATION_TABLE
		PAGE
;-----------------------------------------------------------------------;
;									;
;	BUILD THE OPERATION TABLE FOR THE DEVICE DRIVER 		;
;									;
;-----------------------------------------------------------------------;
OPERATION_TABLE LABEL	NEAR		;START OF OPERATION TABLE
		DW	INITIAL 	;INITIALIZATION ROUTINE ADDRESS
		DW	OK_RETURN	;MEDIA CHECK ROUTINE ADDRESS
		DW	OK_RETURN	;BUILD BPB ROUTINE ADDRESS
		DW	INT_ERROR	;IO CONTROL INPUT ROUTINE ADDRESS
		DW	INPUT		;INPUT (READ) ROUTINE ADDRESS
		DW	NON		;NON-DESTRUCTIVE INPUT ROUTINE ADDRESS
		DW	OK_RETURN	;INPUT STATUS
		DW	INPUT_FLUSH	;INPUT FLUSH
		DW	OUTPUT		;OUTPUT (WRITE) ROUTINE ADDRESS
		DW	OUTPUT		;OUTPUT (WRITE) ROUTINE ADDRESS (VERIFY)
		DW	OK_RETURN	;OUTPUT STATUS
		DW	OK_RETURN	;OUTPUT FLUSH
		%OUT	COMMAND_TABLE
		PAGE
;-----------------------------------------------------------------------;
;									;
;	BUILD THE COMMAND TABLE FOR THE PROGRAM 			;
;									;
;-----------------------------------------------------------------------;
COMMAND_TABLE	LABEL	NEAR		;START OF COMMAND TABLE
		COM	<"A",CUU>       ;CUU COMMAND (CURSOR UP)
		COM	<"B",CUD>       ;CUD COMMAND (CURSOR DOWN)
		COM	<"C",CUF>       ;CUF COMMAND (CURSOR FORWARD)
		COM	<"D",CUB>       ;CUB COMMAND (CURSOR BACKWARD)
		COM	<"H",CUP>       ;CUP COMMAND (CURSOR POSITION)
		COM	<"J",ED>        ;ED COMMAND (ERASE IN DISPLAY)
		COM	<"K",EL>        ;EL COMMAND (ERASE IN LINE)
		COM	<"R",CPR>       ;CPR COMMAND (CURSOR POSITION REPORT)
		COM	<"f",HVP>       ;HVP COMMAND (HOR. AND VERT. POSITION)
		COM	<"h",SM>        ;SM COMMAND (SET MODE)
		COM	<"l",RM>        ;RM COMMAND (RESET MODE)
		COM	<"m",SGR>       ;SGR COMMAND (SET GRAPHICS RENDITION)
		COM	<"n",DSR>       ;DSR COMMAND (DEVICE STATUS REPORT)
		COM	<"p",KKR>       ;KKR COMMAND (KEYBOARD KEY REASSIGNMENT)
		COM	<"s",SCP>       ;SCP COMMAND (SAVE CURSOR POSITION)
		COM	<"u",RCP>       ;RCP COMMAND (RESTORE CURSOR POSITION)
		DB	0		;END OF COMMAND TABLE
		%OUT	RENDITION_TABLE
		PAGE
;-----------------------------------------------------------------------;
;									;
;	BUILD THE GRAPHICS RENDITION TABLE FOR THE PROGRAM		;
;									;
;-----------------------------------------------------------------------;
RENDITION_TABLE LABEL	NEAR		;START OF GRAPHICS RENDITION TABLE
		REN	<00H,000H,07H>	;MODE  0 ALL ATTRIBUTES OFF
		REN	<01H,0FFH,08H>	;MODE  1 BOLD ON (HIGH INTENSITY)
		REN	<04H,0F8H,01H>	;MODE  3 UNDERSCORE ON (MONO. ONLY)
		REN	<05H,0FFH,80H>	;MODE  5 BLINK ON
		REN	<07H,0F8H,70H>	;MODE  7 REVERSE VIDEO ON
		REN	<08H,088H,00H>	;MODE  8 CANCELLED ON (INVISIBLE)
		REN	<1EH,0F8H,00H>	;MODE 30 BLACK FOREGROUND
		REN	<1FH,0F8H,04H>	;MODE 31 RED FOREGROUND
		REN	<20H,0F8H,02H>	;MODE 32 GREEN FOREGROUND
		REN	<21H,0F8H,06H>	;MODE 33 YELLOW FOREGROUND
		REN	<22H,0F8H,01H>	;MODE 34 BLUE FOREGROUND
		REN	<23H,0F8H,05H>	;MODE 35 MAGENTA FOREGROUND
		REN	<24H,0F8H,03H>	;MODE 36 CYAN FOREGROUND
		REN	<25H,0F8H,07H>	;MODE 37 WHITE FOREGROUND
		REN	<28H,08FH,00H>	;MODE 40 BLACK BACKGROUND
		REN	<29H,08FH,40H>	;MODE 41 RED BACKGROUND
		REN	<2AH,08FH,20H>	;MODE 42 GREEN BACKGROUND
		REN	<2BH,08FH,60H>	;MODE 43 YELLOW BACKGROUND
		REN	<2CH,08FH,10H>	;MODE 44 BLUE BACKGROUND
		REN	<2DH,08FH,50H>	;MODE 45 MAGENTA BACKGROUND
		REN	<2EH,08FH,30H>	;MODE 46 CYAN BACKGROUND
		REN	<2FH,08FH,70H>	;MODE 47 WHITE BACKGROUND
		DB	0FFH		;END OF GRAPHICS RENDITION TABLE
		%OUT	REQUEST HEADER STORAGE AREA
		PAGE
;-----------------------------------------------------------------------;
;									;
;	REQUEST HEADER ADDRESS STORAGE AREA (ADDRESS STORED BY STRAT)	;
;									;
;-----------------------------------------------------------------------;
HEADER_OFFSET	DW	0		;REQUEST HEADER OFFSET STORAGE AREA
HEADER_SEGMENT	DW	0		;REQUEST HEADER SEGMENT STOARGE AREA
		%OUT	STRAGETY
		PAGE
;-----------------------------------------------------------------------;
;									;
;	DEVICE STRATEGY PROCEDURE					;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   ES		REQUEST HEADER SEGMENT POINTER	;
;			   BX		REQUEST HEADER OFFSET POINTER	;
;									;
;	ON RETURN:							;
;									;
;			ADDRESS OF REQUEST HEADER IS SAVED FOR USE	;
;			BY THE DEVICE INTERRUPT PROCEDURE.		;
;									;
;-----------------------------------------------------------------------;
STRATEGY	PROC	FAR		;START OF DEVICE STRATEGY PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	SAVE POINTER TO REQUEST HEADER					;
;									;
;-----------------------------------------------------------------------;
		MOV	[CS:HEADER_OFFSET],BX
		MOV	[CS:HEADER_SEGMENT],ES
		RET
STRATEGY	ENDP			;END OF DEVICE STRAGETY PROCEDURE
		%OUT	INTERRUPT
		PAGE
;-----------------------------------------------------------------------;
;									;
;	DEVICE INTERRUPT PROCEDURE					;
;									;
;	ON ENTRY:							;
;									;
;			REQUEST HEADER ADDRESS WAS SAVED BY THE 	;
;			DEVICE STRATEGY ROUTINE AND WILL BE USED	;
;			TO PERFORM THE REQUESTED OPERATION.		;
;									;
;	ON RETURN:							;
;									;
;			THE REQUESTED OPERATION WILL HAVE BE PERFORMED	;
;			AND THE REQUEST HEADER STATUS WORD WILL REFLECT ;
;			THE STATUS AT THE COMPLETETION OF THE REQUESTED ;
;			OPERATION.					;
;									;
;-----------------------------------------------------------------------;
INTERRUPT	PROC	FAR		;START OF DEVICE INTERRUPT PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	SAVE ALL THE REGISTERS TO BE USED				;
;									;
;-----------------------------------------------------------------------;
		PUSH	SI
		PUSH	AX
		PUSH	CX
		PUSH	DX
		PUSH	DI
		PUSH	BP
		PUSH	DS
		PUSH	ES
		PUSH	BX
;-----------------------------------------------------------------------;
;									;
;	GET REQUEST HEADER DATA AND OPERATION CODE			;
;									;
;-----------------------------------------------------------------------;
		LDS	BX,DWORD PTR [CS:HEADER_OFFSET]
		MOV	CX,[BX+DATA]
		MOV	AL,[BX].COMMAND_CODE
		CBW
		PAGE
;-----------------------------------------------------------------------;
;									;
;	COMPUTE OFFSET INTO OPERATION TABLE TO GET ADDRESS FROM 	;
;									;
;-----------------------------------------------------------------------;
		MOV	SI,OFFSET OPERATION_TABLE
		ADD	SI,AX
		ADD	SI,AX
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A VALID OPERATION CODE (LESS THAN 12) 		;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,OP_MAXIMUM
		JA	SHORT INT_ERROR
;-----------------------------------------------------------------------;
;									;
;	GET BUFFER ADDRESS FROM HEADER AND JUMP TO OPERATION ROUTINE	;
;									;
;-----------------------------------------------------------------------;
		LES	DI,DWORD PTR [BX+BUFF]
		PUSH	CS
		POP	DS
		JMP	WORD PTR [SI]
;-----------------------------------------------------------------------;
;									;
;	NON-DESTRUCTIVE INPUT (READ) ERROR SECTION			;
;									;
;-----------------------------------------------------------------------;
INPUT_ERROR	LABEL	NEAR
		MOV	AH,BUS+DON
		JMP	SHORT INT_RETURN
;-----------------------------------------------------------------------;
;									;
;	ALL OTHER ERRORS RETURN HERE (UNKNOWN OPERATION ERROR)		;
;									;
;-----------------------------------------------------------------------;
INT_ERROR	LABEL	NEAR
		MOV	AL,UNK_COMMAND
		MOV	AH,ERR+DON
		JMP	SHORT INT_RETURN
;-----------------------------------------------------------------------;
;									;
;	RETURN TO HERE IF EVERYTHING WENT OK (SET NO ERROR BITS)	;
;									;
;-----------------------------------------------------------------------;
OK_RETURN	LABEL	NEAR
		MOV	AH,DON
		PAGE
INT_RETURN	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	STORE STATUS WORD IN THE REQUEST HEADER 			;
;									;
;-----------------------------------------------------------------------;
		LDS	BX,DWORD PTR [CS:HEADER_OFFSET]
		MOV	[BX].STATUS_WORD,AX
;-----------------------------------------------------------------------;
;									;
;	RESTORE ALL THE SAVED REGISTERS 				;
;									;
;-----------------------------------------------------------------------;
		POP	BX
		POP	ES
		POP	DS
		POP	BP
		POP	DI
		POP	DX
		POP	CX
		POP	AX
		POP	SI
;-----------------------------------------------------------------------;
;									;
;	RETURN FROM DEVICE INTERRUPT ROUTINE (OPERATION COMPLETED)	;
;									;
;-----------------------------------------------------------------------;
		RET
INTERRUPT	ENDP			;END OF DEVICE INTERRUPT PROCEDURE
		%OUT	CTRL_BREAK
		PAGE
;-----------------------------------------------------------------------;
;									;
;	CONTROL BREAK INTERRUPT PROCEDURE				;
;									;
;	ON ENTRY:							;
;									;
;			THIS PROCEDURE IS ENTERED IF A CTRL-BREAK IS	;
;			KEYED.						;
;									;
;	ON RETURN:							;
;									;
;			THE INPUT BUFFER IS SET UP SO THAT THE NEXT	;
;			CHARACTER RETURNED BY THE DEVICE DRIVER IS	;
;			A BREAK CHARACTER. (IT DOES THIS BY USING	;
;			THE EXTENDED CHARACTER BUFFER.) 		;
;									;
;-----------------------------------------------------------------------;
CTRL_BREAK	PROC	NEAR		;KEYBOARD BREAK INTERRUPT PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	SAVE BREAK CHARACTER INTO EXTENDED CHARACTER SAVE AREA		;
;									;
;-----------------------------------------------------------------------;
		MOV	[CS:EXTENDED],BREAK
		IRET
CTRL_BREAK	ENDP			;END OF KEYBOARD BREAK PROCEDURE
		%OUT	MIDDLE DATA AREA
		PAGE
;-----------------------------------------------------------------------;
;									;
;	MIDDLE DATA AREA (DATA DEFINED IN THE MIDDLE OF THE PROGRAM)	;
;									;
;-----------------------------------------------------------------------;
WRAP_FLAG	DB	0		;WRAP-AROUND FLAG BYTE
TABLE_OFFSET	DW	OFFSET TRANS_START - OFFSET TRANS_BUFF
OUTPUT_ADDRESS	DW	OUTPUT_FOUR	;CURRENT OUTPUT ROUTINE ADDRESS
MODE		LABEL	WORD		;CRT MODE AND NUMBER COLUMNS
CURR_MODE	DB	03H		;CURRENT CRT MODE
NUM_COLUMN	DB	4FH		;MAXIMUM NUMBER OF COLUMNS ON SCREEN
CURSOR_POSITION LABEL	WORD		;CURRENT CURSOR POSITION
COLUMN		DB	0		;CURRENT COLUMN NUMBER
ROW		DB	0		;CURRENT ROW NUMBER
CURSOR_SAVE	DW	0		;CURSOR POSITION SAVE AREA
DELIMIT_COUNT	LABEL	WORD		;DELIMITER CHARACTER AND PARAMETER COUNT
DELIMIT_CHAR	DB	0		;CURRENT DELIMITER CHARACTER
PARM_CNT	LABEL	WORD		;PARAMETER COUNTER
PARM_COUNT	DB	0		;PARAMETER COUNTER
PARM_DUMMY	DB	0		;DUMMY MSB BYTE FOR PARAMETER COUNTER
REPLACE_COUNT	DB	0		;REPLACEMENT CHARACTER COUNT
REPLACE_PTR	DW	OFFSET TRANS_BUFF
CPR_MSG 	LABEL	NEAR		;CURSOR POSTION REPORT MESSAGE FORM
		DB	1BH		;ASCII ESCAPE CHARACTER
		DB	"["
MSG_ROW 	DW	3030H		;CURSOR POSITION ROW AREA
		DB	";"
MSG_COLUMN	DW	3030H		;CURSOR POSITION COLUMN AREA
		DB	"R"
		DB	0DH		;ASCII CARRIAGE RETURN CHARACTER
EXTENDED	DB	0		;SECOND HALF OF EXTENDED CODE ENTRIES
ATTR_PAGE	LABEL	WORD		;CURRENT ATTRIBUTE AND ACTIVE PAGE
ATTR		DB	07H		;CURRENT ATTRIBUTE BYTE
PAG		DB	0		;CURRENT DISPLAY PAGE NUMBER
SCREEN_ADDRESS	DW	GRAPHICS	;SCREEN MEMORY SEGMENT ADDRESS
REGEN_ADDRESS	DW	0		;STARTING SEGEMENT IN REGEN BUFFER
		%OUT	ACTUAL_OUTPUT
		PAGE
;-----------------------------------------------------------------------;
;									;
;	ACTUAL OUTPUT PROCEDURE 					;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   AL		CHARACTER TO BE PRINTED 	;
;									;
;	ON RETURN:							;
;									;
;			REQUESTED CHARACTER, AND ATTRIBUTE BYTE IF	;
;			NEEDED, WILL BE DISPLAYED ON THE SCREEN IN	;
;			THE CURRENT CRT MODE AT THE CURRENT CURSOR	;
;			POSITION. CURRENT ROW AND COLUMN NUMBER WILL	;
;			BE UPDATED ACCORDING TO THE CHARACTER.		;
;									;
;-----------------------------------------------------------------------;
ACTUAL_OUTPUT	PROC	NEAR		;START OF THE ACTUAL OUTPUT PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A CARRIAGE RETURN (ZERO COLUMN IF MATCH)		;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,CR
		JNZ	SHORT NOT_CR
		MOV	[DS:COLUMN],ZERO
		JMP	SHORT RE_POSITION
NOT_CR		LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A LINE FEED (GO INCREMENT ROW IF MATCH)		;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,LF
		JZ	SHORT IS_LF
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A BELL (JUMP TO NEXT CHECK IF NOT A BELL)		;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,BELL
		JNZ	SHORT NOT_BELL
;-----------------------------------------------------------------------;
;									;
;	WRITE CHARACTER THROUGH TTY SERVICE (HANDLES SPECIAL CHARS.)	;
;									;
;-----------------------------------------------------------------------;
WRT_TTY 	LABEL	NEAR
		MOV	BX,[DS:ATTR_PAGE]
		AND	BL,FORE_MASK
		MOV	AH,WRITE_TTY
		VIDEO
		PAGE
;-----------------------------------------------------------------------;
;									;
;	BRANCH TO HERE TO RETURN FROM ACTUAL OUTPUT PROCEDURE		;
;									;
;-----------------------------------------------------------------------;
ACTUAL_RETURN	LABEL	NEAR
		RET
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A BACKSPACE (GO TO WRITE CHARACTER AND ATTR. IF NOT)	;
;									;
;-----------------------------------------------------------------------;
NOT_BELL	LABEL	NEAR
		CMP	AL,BACK_SPACE
		JNZ	SHORT NOT_BS
;-----------------------------------------------------------------------;
;									;
;	ATTEMPT TO DO THE ACTUAL BACKSPACE				;
;									;
;-----------------------------------------------------------------------;
		CMP	[DS:COLUMN],ZERO
		JZ	SHORT ACTUAL_RETURN
		DEC	[DS:COLUMN]
		JMP	SHORT RE_POSITION
;-----------------------------------------------------------------------;
;									;
;	WRITE THE CHARACTER AND ATTRIBUTE TO THE DISPLAY SCREEN 	;
;									;
;-----------------------------------------------------------------------;
NOT_BS		LABEL	NEAR
		MOV	BX,[DS:ATTR_PAGE]
		MOV	CX,1
		MOV	AH,WRITE_CHAR
		VIDEO
;-----------------------------------------------------------------------;
;									;
;	UPDATE THE CURRENT CURSOR POSITION AND GO REPOSITION CURSOR	;
;									;
;-----------------------------------------------------------------------;
		INC	[DS:COLUMN]
		MOV	AL,[DS:COLUMN]
		CMP	AL,[DS:NUM_COLUMN]
		JBE	SHORT RE_POSITION
		CMP	[DS:WRAP_FLAG],OFF
		JZ	SHORT DO_WRAP
		DEC	[DS:COLUMN]
		RET
		PAGE
;-----------------------------------------------------------------------;
;									;
;	WRAP FLAG IS ON, WRAP TO A NEW LINE HERE (COLUMN NOW ZERO)	;
;									;
;-----------------------------------------------------------------------;
DO_WRAP 	LABEL	NEAR
		MOV	[DS:COLUMN],ZERO
;-----------------------------------------------------------------------;
;									;
;	HANDLE A LINE FEED HERE (INCREMENT THE ROW NUMBER)		;
;									;
;-----------------------------------------------------------------------;
IS_LF		LABEL	NEAR
		INC	[DS:ROW]
		CMP	[DS:ROW],NUM_ROW
		JB	SHORT RE_POSITION
		MOV	[DS:ROW],LAST_LINE
		CALL	SHORT SCROLL
;-----------------------------------------------------------------------;
;									;
;	LOAD CURRENT ROW AND COLUMN AND REPOSITION THE CURSOR		;
;									;
;-----------------------------------------------------------------------;
RE_POSITION	LABEL	NEAR
		MOV	DH,[DS:ROW]
		MOV	DL,[DS:COLUMN]
		MOV	BH,[DS:PAG]
		MOV	AH,POSITION_CURSOR
		VIDEO
		RET
;-----------------------------------------------------------------------;
;									;
;	ROUTINE TO SCROLL THE CRT DISPLAY SCREEN			;
;									;
;-----------------------------------------------------------------------;
SCROLL		LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR 80 COLUMN MODES (HANDLE THEM SPECIAL) 		;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,[DS:CURR_MODE]
		CMP	AL,BW80
		JZ	SHORT ROLL
		CMP	AL,COLOR80
		JZ	SHORT ROLL
		MOV	AL,LF
		JMP	SHORT WRT_TTY
		PAGE
;-----------------------------------------------------------------------;
;									;
;	80 COLUMN MODE, SET UP POINTERS FOR THE SCROLL			;
;									;
;	BH - CURRENT ATTRIBUTE BYTE					;
;	BL - ASCII BLANK						;
;	BP - CHARACTER COUNT (DECIMAL 80)				;
;	DS - SCREEN ADDRESS SEGMENT VALUE				;
;	ES - SCREEN ADDRESS SEGMENT VALUE				;
;	DI - POINTER TO FIRST DISPLAY LINE				;
;	SI - POINTER TO SECOND DISPLAY					;
;	CX - COUNT OF CHARACTERS TO MOVE				;
;									;
;-----------------------------------------------------------------------;
ROLL		LABEL	NEAR
		MOV	BH,[DS:ATTR]
		MOV	BL,SPACE
		MOV	BP,COUNT_80
		MOV	AX,[DS:SCREEN_ADDRESS]
		ADD	AX,[DS:REGEN_ADDRESS]
		MOV	ES,AX
		MOV	DS,AX
		XOR	DI,DI
		MOV	SI,SECOND
		MOV	CX,CHAR_COUNT
		CLD
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A COLOR GRAPHICS SCREEN (HANDLE DIFFERENT)		;
;									;
;-----------------------------------------------------------------------;
		CMP	[CS:SCREEN_ADDRESS],GRAPHICS
		JZ	SHORT ROLL_COLOR
;-----------------------------------------------------------------------;
;									;
;	DO THE SCROLL AND BLANK THE LAST LINE FOR MONO-CHROME		;
;									;
;-----------------------------------------------------------------------;
		REPZ	MOVSW
		MOV	AX,BX
		MOV	CX,BP
		REPZ	STOSW
;-----------------------------------------------------------------------;
;									;
;	JUMP TO HERE TO RETURN FROM THE SCROLL DISPLAY ROUTINE		;
;									;
;-----------------------------------------------------------------------;
ROLL_RETURN	LABEL	NEAR
		PUSH	CS
		POP	DS
		RET
		PAGE
;-----------------------------------------------------------------------;
;									;
;	COLOR GRAPHICS SCREEN SCROLL SECTION				;
;									;
;-----------------------------------------------------------------------;
ROLL_COLOR	LABEL	NEAR
		MOV	DX,STATUS_PORT
;-----------------------------------------------------------------------;
;									;
;	WAIT UNTIL IN VERTICAL RETRACE					;
;									;
;-----------------------------------------------------------------------;
NOT_YET 	LABEL	NEAR
		IN	AL,DX
		TEST	AL,VER_RETRACE
		JZ	SHORT NOT_YET
;-----------------------------------------------------------------------;
;									;
;	IN VERTICAL RETRACE, TURN OFF THE VIDEO SIGNAL FIRST		;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,VIDEO_OFF
		MOV	DX,MODE_PORT
		OUT	DX,AL
;-----------------------------------------------------------------------;
;									;
;	DO THE SCROLL AND BLANK LAST LINE FOR COLOR GRAPHICS SCREEN	;
;									;
;-----------------------------------------------------------------------;
		REPZ	MOVSW
		MOV	AX,BX
		MOV	CX,BP
		REPZ	STOSW
;-----------------------------------------------------------------------;
;									;
;	TURN THE VIDEO SIGNAL BACK ON AND RETURN FROM THE ROUTINE	;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,VIDEO_ON
		MOV	DX,MODE_PORT
		OUT	DX,AL
		JMP	SHORT ROLL_RETURN
ACTUAL_OUTPUT	ENDP			;END OF THE ACTUAL_OUTPUT PROCEDURE
		%OUT	INPUT
		PAGE
;-----------------------------------------------------------------------;
;									;
;	INPUT (READ) PROCEDURE						;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   DS		REQUEST HEADER SEG. POINTER	;
;			   BX		REQUEST HEADER OFF. POINTER	;
;			   ES		TRANSFER ADDRESS SEG. POINTER	;
;			   DI		TRANSFER ADDRESS OFF. POINTER	;
;			   CX		REQUESTED BYTE COUNT		;
;									;
;	ON RETURN:							;
;									;
;			THE TRANSFER ADDRESS (BUFFER AREA) WILL CONTAIN ;
;			THE INPUT CHARACTERS AND THE REQUEST HEADER	;
;			STATUS WORD WILL BE SET.			;
;									;
;-----------------------------------------------------------------------;
INPUT		PROC	NEAR		;INPUT (READ) PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR INPUT WITH ZERO BYTE COUNT (JUST RETURN)		;
;									;
;-----------------------------------------------------------------------;
		JCXZ	SHORT INP_RETURN
GET		LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	LOOP THROUGH AND GET THE REQUESTED CHARACTERS AND SAVE THEM	;
;									;
;-----------------------------------------------------------------------;
		PUSH	CX
		CALL	SHORT READ
		POP	CX
		STOSB
		LOOP	SHORT GET
;-----------------------------------------------------------------------;
;									;
;	JUMP HERE TO RETURN FROM THE INPUT OPERATION			;
;									;
;-----------------------------------------------------------------------;
INP_RETURN	LABEL	NEAR
		JMP	OK_RETURN
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR SECOND HALF OF EXTENDED CHARACTER FIRST		;
;									;
;-----------------------------------------------------------------------;
READ		LABEL	NEAR
		XOR	AX,AX
		XCHG	[DS:EXTENDED],AL
		OR	AL,AL
		JNZ	SHORT READ_RETURN
		PAGE
;-----------------------------------------------------------------------;
;									;
;	NO EXTENDED CHARACTER, CHECK FOR REPLACEMENT CHARACTERS NEXT	;
;									;
;-----------------------------------------------------------------------;
RETRY		LABEL	NEAR
		CMP	[DS:REPLACE_COUNT],ZERO
		JNZ	SHORT GET_CHAR
;-----------------------------------------------------------------------;
;									;
;	NO REPLACEMENT CHARACTERS, CALL BIOS TO READ KEYBOARD		;
;									;
;-----------------------------------------------------------------------;
		XOR	AH,AH
		KEYBOARD
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR INPUT CHARACTER BEING A REPLACEMENT CHARACTER 	;
;									;
;-----------------------------------------------------------------------;
		CALL	SHORT CHECK_REPLACE
		JNZ	SHORT CHAR_CHECK
;-----------------------------------------------------------------------;
;									;
;	REPLACEMENT CHARACTER, GET REPLACEMENT COUNT AND POINTER	;
;									;
;-----------------------------------------------------------------------;
		DEC	CX
		DEC	CX
		INC	BX
		INC	BX
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR EXTENDED CHARACTER, IF SO CORRECT COUNT AND POINTER	;
;									;
;-----------------------------------------------------------------------;
		OR	AL,AL
		JNZ	SHORT PTR_CORRECT
		DEC	CX
		INC	BX
;-----------------------------------------------------------------------;
;									;
;	SAVE REPLACEMENT COUNTER AND POINTER AND GET FIRST CHARACTER	;
;									;
;-----------------------------------------------------------------------;
PTR_CORRECT	LABEL	NEAR
		MOV	[DS:REPLACE_COUNT],CL
		MOV	[DS:REPLACE_PTR],BX
		CALL	SHORT GET_CHAR
		PAGE
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A NUL CHARACTER, IF SO THEN GO RETRY THE READ 	;
;									;
;-----------------------------------------------------------------------;
CHAR_CHECK	LABEL	NEAR
		OR	AX,AX
		JZ	SHORT RETRY
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR AN EXTENDED ASCII CODE, IF SO THEN SAVE SECOND HALF	;
;									;
;-----------------------------------------------------------------------;
		OR	AL,AL
		JNZ	SHORT READ_RETURN
		MOV	[DS:EXTENDED],AH
;-----------------------------------------------------------------------;
;									;
;	JUMP HERE TO RETURN FROM READ CHARACTER ROUTINE 		;
;									;
;-----------------------------------------------------------------------;
READ_RETURN	LABEL	NEAR
		RET
;-----------------------------------------------------------------------;
;									;
;	ROUTINE TO GET A REPLACEMENT CHARACTER FROM TABLE		;
;									;
;-----------------------------------------------------------------------;
GET_CHAR	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET REPLACEMENT CHARACTER AND THEN UPDATE COUNTER AND POINTER	;
;									;
;-----------------------------------------------------------------------;
		MOV	BX,[DS:REPLACE_PTR]
		MOV	AX,[BX]
		DEC	[DS:REPLACE_COUNT]
		INC	BX
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR AN EXTENDED CODE, IF SO CORRECT COUNTER AND POINTER	;
;									;
;-----------------------------------------------------------------------;
		OR	AL,AL
		JNZ	SHORT BUFF_CORRECT
		INC	BX
		DEC	[DS:REPLACE_COUNT]
;-----------------------------------------------------------------------;
;									;
;	SAVE THE UPDATED REPLACE POINTER AND RETURN CHARACTER TO CALLER ;
;									;
;-----------------------------------------------------------------------;
BUFF_CORRECT	LABEL	NEAR
		MOV	[DS:REPLACE_PTR],BX
		RET
		PAGE
;-----------------------------------------------------------------------;
;									;
;	ROUTINE TO CHECK FOR BEING A REPLACEMENT CHARACTER		;
;									;
;-----------------------------------------------------------------------;
CHECK_REPLACE	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET THE OFFSET TO THE TRANSLATION TABLE BUFFER			;
;									;
;-----------------------------------------------------------------------;
		MOV	BX,OFFSET TRANS_BUFF
CHECK_LOOP	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET ENTRY SIZE & CHECK FOR END-OF-TABLE (RETURN NO MATCH IF SO) ;
;									;
;-----------------------------------------------------------------------;
		MOV	CL,[BX]
		XOR	CH,CH
		OR	CX,CX
		JZ	SHORT NO_MATCH_RETURN
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR EXTENDED CODE TABLE ENTRY, DO SPECIAL CHECK IF SO	;
;									;
;-----------------------------------------------------------------------;
		OR	AL,AL
		JNZ	SHORT REGULAR_CHECK
		CMP	AX,[BX+1]
		JMP	SHORT MATCH_CHECK
REGULAR_CHECK	LABEL	NEAR
		CMP	AL,[BX+1]
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A MATCH (RETURN IF SO, ELSE GO TO NEXT TABLE ENTRY)	;
;									;
;-----------------------------------------------------------------------;
MATCH_CHECK	LABEL	NEAR
		JZ	SHORT MATCH_RETURN
		ADD	BX,CX
		JMP	SHORT CHECK_LOOP
NO_MATCH_RETURN LABEL	NEAR
		OR	BX,BX
;-----------------------------------------------------------------------;
;									;
;	JUMP HERE TO RETURN FROM THE CHECK REPLACEMENT ROUTINE		;
;									;
;-----------------------------------------------------------------------;
MATCH_RETURN	LABEL	NEAR
		RET
INPUT		ENDP			;END OF INPUT PROCEDURE
		%OUT	NON
		PAGE
;-----------------------------------------------------------------------;
;									;
;	NON-DESTRUCTIVE INPUT (READ) PROCEDURE				;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   DS		REQUEST HEADER SEG. POINTER	;
;			   BX		REQUEST HEADER OFF. POINTER	;
;									;
;	ON RETURN:							;
;									;
;			A BYTE FROM THE KEYBOARD WILL BE RETURNED IF	;
;			ONE IS AVAILABLE AND THE STATUS WORD IN THE	;
;			REQUEST HEADER WILL BE SET TO INDICATE WEATHER	;
;			A CHARACTER WAS AVAILABLE OR NOT.		;
;									;
;-----------------------------------------------------------------------;
NON		PROC	NEAR
NON_TRY 	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR EXTENDED CODE AVAILABLE (RETURN IT IF SO)		;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,[DS:EXTENDED]
		OR	AL,AL
		JNZ	SHORT NON_RETURN
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR REPLACEMENT CHARACTER AVAILABLE (RETURN IT IF SO)	;
;									;
;-----------------------------------------------------------------------;
		CMP	[DS:REPLACE_COUNT],ZERO
		JZ	SHORT CHECK_KEY
		MOV	BX,[DS:REPLACE_PTR]
		MOV	AL,[BX]
		JMP	SHORT NON_RETURN
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR CHARACTER WAITING IN KEYBOARD BUFFER (ERROR IF NONE)	;
;									;
;-----------------------------------------------------------------------;
CHECK_KEY	LABEL	NEAR
		MOV	AH,INPUT_CHECK
		KEYBOARD
		JZ	SHORT NON_ERROR
		PAGE
;-----------------------------------------------------------------------;
;									;
;	CHARACTER WAITING, GET IT AND CHECK FOR NUL (GO TRY AGAIN IF SO);
;									;
;-----------------------------------------------------------------------;
		OR	AX,AX
		JNZ	SHORT NON_CHECK
		MOV	AH,KEYBOARD_INPUT
		KEYBOARD
		JMP	SHORT NON_TRY
;-----------------------------------------------------------------------;
;									;
;	GOT CHARACTER CHECK FOR REPLACEMENT (RETURN CHARACTER IF NOT)	;
;									;
;-----------------------------------------------------------------------;
NON_CHECK	LABEL	NEAR
		CALL	SHORT CHECK_REPLACE
		JNZ	SHORT NON_RETURN
;-----------------------------------------------------------------------;
;									;
;	REPLACEMENT CHARACTER GET REPLACEMENT (REGULAR OR EXTENDED)	;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,[BX+2]
		CMP	BYTE PTR [BX+1],ZERO
		JNZ	SHORT NON_RETURN
		MOV	AL,[BX+3]
;-----------------------------------------------------------------------;
;									;
;	JUMP HERE TO SAVE CHARACTER IN REQUEST HEADER AND RETURN	;
;									;
;-----------------------------------------------------------------------;
NON_RETURN	LABEL	NEAR
		LDS	BX,DWORD PTR [DS:HEADER_OFFSET]
		MOV	[BX+CHAR],AL
;-----------------------------------------------------------------------;
;									;
;	JUMP HERE TO RETURN FROM DEVICE OPERATION			;
;									;
;-----------------------------------------------------------------------;
OP_RETURN	LABEL	NEAR
		JMP	OK_RETURN
;-----------------------------------------------------------------------;
;									;
;	JUMP HERE FOR NO CHARACTER AVAILABLE (GO RETURN ERROR CODE)	;
;									;
;-----------------------------------------------------------------------;
NON_ERROR	LABEL	NEAR
		JMP	INPUT_ERROR
NON		ENDP			;END OF NON PROCEDURE
		%OUT	INPUT_FLUSH
		PAGE
;-----------------------------------------------------------------------;
;									;
;	INPUT FLUSH PROCEDURE						;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   DS		REQUEST HEADER SEG. POINTER	;
;			   BX		REQUEST HEADER OFF. POINTER	;
;									;
;	ON RETURN:							;
;									;
;			THE INPUT BUFFER WILL BE FLUSHED AND THE	;
;			STATUS WORD IN THE REQUEST HEADER WILL BE	;
;			SET.						;
;									;
;-----------------------------------------------------------------------;
INPUT_FLUSH	PROC	NEAR		;INPUT FLUSH PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	ZERO EXTENDED CHARACTER AREA AND REPLACEMENT COUNTER		;
;									;
;-----------------------------------------------------------------------;
		MOV	[DS:EXTENDED],ZERO
		MOV	[DS:REPLACE_COUNT],ZERO
;-----------------------------------------------------------------------;
;									;
;	ZERO THE BIOS KEYBOARD CIRCULAR BUFFER THEN RETURN		;
;									;
;-----------------------------------------------------------------------;
		PUSH	DS
		XOR	BP,BP
		MOV	DS,BP
		MOV	[DS:BUFF_HEAD],BUFF_PTR
		MOV	[DS:BUFF_TAIL],BUFF_PTR
		POP	DS
		JMP	SHORT OP_RETURN
INPUT_FLUSH	ENDP			;END OF INPUT_FLUSH PROCEDURE
		%OUT	OUTPUT
		PAGE
;-----------------------------------------------------------------------;
;									;
;	OUTPUT (WRITE)/VERIFY  PROCEDURE				;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   DS		REQUEST HEADER SEG. POINTER	;
;			   BX		REQUEST HEADER OFF. POINTER	;
;			   ES		TRANSFER ADDRESS SEG. POINTER	;
;			   DI		TRANSFER ADDRESS OFF. POINTER	;
;			   CX		REQUESTED BYTE COUNT		;
;									;
;	ON RETURN:							;
;									;
;			THE REQUESTED CHARACTER(S) WILL BE DISPLAYED ON ;
;			THE SCREEN UNLESS THEY ARE PART OF ONE OF THE	;
;			MANY ESCAPE SEQUENCES RECOGNIZED BY THIS	;
;			PROGRAM. IN THE CASE WHERE THEY ARE PART OF THE ;
;			SEQUENCE THE CHARACTER(S) WILL BE USED TO DO	;
;			THE REQUESTED FUNCTION AND WILL NOT BE		;
;			DISPLAYED UPON THE CRT SCREEN.			;
;									;
;-----------------------------------------------------------------------;
OUTPUT		PROC	NEAR		;OUTPUT/VERIFY OUTPUT PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A ZERO BYTE COUNT (JUST RETURN IF SO) 		;
;									;
;-----------------------------------------------------------------------;
		JCXZ	SHORT OP_RETURN
CHAR_OUTPUT	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET A OUTPUT CHARACTER FROM THE BUFFER AND INCREMENT POINTER	;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,ES:[DI]
		INC	DI
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR ANY SPECIAL SEQUENCES AND LOOP UNTIL DONE THEN RETURN ;
;									;
;-----------------------------------------------------------------------;
		CALL	SHORT HANDLE_CHAR
		LOOP	SHORT CHAR_OUTPUT
		JMP	SHORT OP_RETURN
		PAGE
;-----------------------------------------------------------------------;
;									;
;	INTERRUPT 29H ROUTINE (INTERNAL DOS PRINT CHARACTER INTERRUPT)	;
;									;
;-----------------------------------------------------------------------;
INT_29		LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	RESET INTERRUPTS AND CALL ROUTINE TO HANDLE THE CHARACTER	;
;									;
;-----------------------------------------------------------------------;
		STI
		PUSH	DS
		PUSH	CS
		POP	DS
		CALL	SHORT HANDLE_CHAR
		POP	DS
		IRET
		PAGE
;-----------------------------------------------------------------------;
;									;
;	ROUTINE TO HANDLE OUTPUT CHARACTERS (FIRST SAVE ALL REGISTERS)	;
;									;
;-----------------------------------------------------------------------;
HANDLE_CHAR	LABEL	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX
		PUSH	SI
		PUSH	DI
		PUSH	ES
		PUSH	BP
;-----------------------------------------------------------------------;
;									;
;	SET UP THE FOLLOWING DATA AREAS:				;
;									;
;	SCREEN_ADDRESS	- DISPLAY SCREEN MEMORY STARTING ADDRESS	;
;	MODE		- CURRENT CRT MODE SELECTED			;
;	PAG		- CURRENT ACTIVE PAGE NUMBER			;
;	CURSOR_POSITION - CURRENT CURSOR POSITION			;
;	REGEN_ADDRESS	- STARTING ADDRESS IN REGEN BUFFER (SEGMENT)	;
;									;
;-----------------------------------------------------------------------;
		MOV	[DS:SCREEN_ADDRESS],GRAPHICS
		XCHG	SI,AX
		MOV	AX,DATA_SEGMENT
		MOV	DS,AX
		MOV	AX,WORD PTR [DS:CRT_MODE]
		DEC	AH
		MOV	[CS:MODE],AX
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR THE MONOCHROME DISPLAY OR COLOR GRAPHICS DISPLAY	;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,MONO_MODE
		JNZ	SHORT NOT_MONO
		MOV	[CS:SCREEN_ADDRESS],MONO_CHROME
NOT_MONO	LABEL	NEAR
		MOV	AL,[DS:ACTIVE_PAGE]
		MOV	[CS:PAG],AL
		CBW
		ADD	AX,AX
		MOV	BX,AX
		MOV	AX,[BX+CURSOR_POSN]
		MOV	[CS:CURSOR_POSITION],AX
		MOV	AX,[DS:CRT_START]
		PAGE
;-----------------------------------------------------------------------;
;									;
;	CONVERT REGEN VALUE TO SEGMENT FORM FOR USE BY PROGRAM		;
;									;
;-----------------------------------------------------------------------;
		MOV	CL,SHIFT
		SHR	AX,CL
		PUSH	CS
		POP	DS
		MOV	[DS:REGEN_ADDRESS],AX
;-----------------------------------------------------------------------;
;									;
;	RESTORE THE CHARACTER TO AL AND GO TO THE OUTPUT ROUTINE	;
;									;
;-----------------------------------------------------------------------;
		XCHG	SI,AX
		CALL	SHORT GO_TO_OUTPUT
;-----------------------------------------------------------------------;
;									;
;	RESTORE ALL THE SAVED REGISTERS AND RETURN TO THE CALLER	;
;									;
;-----------------------------------------------------------------------;
		POP	BP
		POP	ES
		POP	DI
		POP	SI
		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
;-----------------------------------------------------------------------;
;									;
;	JUMP HERE TO GO TO THE CURRENT OUTPUT ROUTINE			;
;									;
;-----------------------------------------------------------------------;
GO_TO_OUTPUT	LABEL	NEAR
		MOV	SI,OFFSET OUTPUT_ADDRESS
		JMP	WORD PTR [SI]
OUTPUT		ENDP			;END OF OUTPUT PROCEDURE
		%OUT	OUTPUT_ONE
		PAGE
;-----------------------------------------------------------------------;
;									;
;	OUTPUT PROCEDURE NUMBER ONE					;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   AL		CHARACTER TO BE OUTPUT		;
;									;
;	ON RETURN:							;
;									;
;			THIS PROCEDURE WILL CHECK FOR THE CHARACTER	;
;			BEING A LEFT BRACKET, IF THE CHARACTER IS	;
;			NOT A LEFT BRACKET THE OUTPUT ADDRESS WILL	;
;			BE RESET TO OUTPUT PROCEDURE FOUR, IF THE	;
;			CHARACTER IS A BRACKET THE OUTPUT ADDRESS	;
;			WILL BE SET TO OUTPUT PROCEDURE TWO AND 	;
;			THE PARAMETER COUNT AND DELIMITER CHARACTER	;
;			WILL BE ZEROED. THIS PROCEDURE WILL TRANSFER	;
;			CONTROL TO OUTPUT PROCEDURE FOUR IF THE 	;
;			CHARACTER IS NOT A LEFT BRACKET.		;
;									;
;-----------------------------------------------------------------------;
OUTPUT_ONE	PROC	NEAR		;OUTPUT PROCEDURE NUMBER ONE
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A LEFT BRAKET, IF NOT GO TO OUTPUT_FOUR PROCEDURE	;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,BRAKET
		JZ	SHORT BRAKET_MATCH
		JMP	OUTPUT_FOUR
;-----------------------------------------------------------------------;
;									;
;	MATCH, SET OUTPUT ADDRESS AS OUTPUT_TWO 			;
;	       ZERO DELIMITER CHARACTER AND PARAMETER COUNTER		;
;	       AND GO CONTINUE WITH THE OUTPUT				;
;									;
;-----------------------------------------------------------------------;
BRAKET_MATCH	LABEL	NEAR
		MOV	WORD PTR [SI],OFFSET OUTPUT_TWO
		XOR	BX,BX
		MOV	[DS:DELIMIT_COUNT],BX
		JMP	SHORT OUTPUT_CONTINUE
OUTPUT_ONE	ENDP			;END OF OUTPUT_ONE PROCEDURE
		%OUT	OUTPUT_TWO
		PAGE
;-----------------------------------------------------------------------;
;									;
;	OUTPUT PROCEDURE TWO						;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   AL		CHARACTER TO BE OUTPUT		;
;									;
;	ON RETURN:							;
;									;
;			THIS PROCEDURE WILL FIRST CHECK FOR THE 	;
;			CHARACTER BEING A SEMI-COLON, IF IT IS		;
;			THIS PROCEDURE WILL INCREMENT THE CURRENT	;
;			PARAMETER COUNT AND RETURN, IF NOT THEN 	;
;			THE CHARACTER IS CHECKED TO SEE IF IT IS	;
;			PART OF A VALID PARAMETER. IF THE CHARACTER	;
;			IS PART OF A PARAMETER IT IS STORED IN THE	;
;			PARAMETER TABLE FOR USE LATER, IF NOT THEN	;
;			IT IS CHECKED TO SEE IF IT IS ONE OF THE VALID	;
;			OPERATION CHARACTERS. IF IT IS ONE OF THE	;
;			VALID OPERATION CHARACTERS THEN THE REQUESTED	;
;			OPERATION IS CALLED, IF NOT THEN THE		;
;			CHARACTER IS OUTPUT TO THE DISPLAY.		;
;			THE CURRENT OUTPUT PROCEDURE ADDRESS IS 	;
;			SET TO OUTPUT PROCEDURE THREE IF THE		;
;			CHARACTER IS A STRING DELIMITER.		;
;									;
;-----------------------------------------------------------------------;
OUTPUT_TWO	PROC	NEAR		;OUTPUT PROCEDURE NUMBER TWO
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A SEMI-COLON (GO CHECK VALUE AS PARAMETER IF NOT)	;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,SEMI_COLON
		JNZ	SHORT PARM_CHECK
INC_PARM	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	INCREMENT THE PARAMETER COUNTER AND CONTINUE WITH THE OUTPUT	;
;									;
;-----------------------------------------------------------------------;
		INC	[DS:PARM_COUNT]
OUTPUT_CONTINUE LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	ZERO WHERE NEW PARAMETER WOULD GO AND RETURN TO THE CALLER	;
;									;
;-----------------------------------------------------------------------;
		CALL	SHORT PARM_ADDRESS
		XOR	AX,AX
		MOV	[BX],AX
		RET
		PAGE
PARM_CHECK	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	CHECK PARAMETER FOR NUMERIC (ADD TO CUR. VALUE AND RETURN IF SO);
;									;
;-----------------------------------------------------------------------;
		CMP	AL,MIN_NUM
		JB	SHORT NOT_NUMERIC
		CMP	AL,MAX_NUM
		JA	SHORT NOT_NUMERIC
		CALL	SHORT PARM_ADDRESS
		SUB	AL,CONVERT
		XCHG	[BX],AL
		MOV	AH,TEN
		MUL	AH
		ADD	[BX],AL
		RET
NOT_NUMERIC	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A DELIMITER CHARACTER NEXT (JUST RETURN IF MATCH)	;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,EQUAL_SIGN
		JZ	SHORT DELIMIT
		CMP	AL,QUESTION_MARK
		JZ	SHORT DELIMIT
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR STRING DELIMITER NEXT (CHECK FOR COMM. IF NOT STRING) ;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,DOUBLE_QUOTE
		JZ	SHORT STRING
		CMP	AL,SINGLE_QUOTE
		JNZ	SHORT CHECK_COMMAND
STRING		LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	STRING DELIMITER, SAVE DELIMITER AND SET OUTPUT AS OUTPUT_THREE ;
;									;
;-----------------------------------------------------------------------;
		MOV	WORD PTR [SI],OFFSET OUTPUT_THREE
		MOV	[DS:DELIMIT_CHAR],AL
DELIMIT 	LABEL	NEAR
		RET
OUTPUT_TWO	ENDP			;END OF OUTPUT_TWO PROCEDURE
		%OUT	OUTPUT_THREE
		PAGE
;-----------------------------------------------------------------------;
;									;
;	OUTPUT PROCEDURE THREE						;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   AL		CHARACTER TO BE OUTPUT		;
;									;
;	ON RETURN:							;
;									;
;			THIS PROCEDURE WILL CHECK TO SEE IF THE 	;
;			CHARACTER MATCHES THE CURRENT STRING		;
;			DELIMITER, IF IT DOES THEN THE PARAMETER	;
;			COUNTER IS DECREMENTED AND THE OUTPUT		;
;			ADDRESS IS SET TO OUTPUT PROCEDURE TWO. 	;
;			IF IT DOES NOT MATCH THE CURRENT DELIMITER	;
;			CHARACTER THEN IT IS PUT INTO THE PARAMETER	;
;			TABLE FOR LATER USE.				;
;									;
;-----------------------------------------------------------------------;
OUTPUT_THREE	PROC	NEAR		;OUTPUT PROCEDURE NUMBER THREE
;-----------------------------------------------------------------------;
;									;
;	CHECK CHARACTER AGAINST CURRENT DELIMITER (SAVE IF NOT) 	;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,[DS:DELIMIT_CHAR]
		JNZ	SHORT NOT_DELIMIT
;-----------------------------------------------------------------------;
;									;
;	MATCHING DELIMITER, CORRECT COUNTER & SET ADDR. TO OUTPUT_TWO	;
;									;
;-----------------------------------------------------------------------;
		DEC	[DS:PARM_COUNT]
		MOV	WORD PTR [SI],OFFSET OUTPUT_TWO
		RET
NOT_DELIMIT	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	NOT STRING DELIMITER, SAVE IN PARAMETER TABLE AND RETURN	;
;									;
;-----------------------------------------------------------------------;
		CALL	SHORT PARM_ADDRESS
		MOV	[BX],AL
		MOV	WORD PTR [SI],OFFSET OUTPUT_THREE
		JMP	SHORT INC_PARM
		PAGE
CHECK_COMMAND	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR A COMMAND ENTRY (FIRST GET COMMAND TABLE OFFSET)	;
;									;
;-----------------------------------------------------------------------;
		MOV	BX,OFFSET COMMAND_TABLE - 3
COMMAND_LOOP	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET ENTRY FROM THE TABLE AND CHECK FOR TABLE END (OUTPUT IF SO) ;
;									;
;-----------------------------------------------------------------------;
		ADD	BX,COM_SIZE
		CMP	BYTE PTR [BX],ZERO
		JZ	SHORT DO_OUTPUT
;-----------------------------------------------------------------------;
;									;
;	NOT END, CHECK CHARACTER AGAINST TABLE ENTRY (LOOP IF NO MATCH) ;
;									;
;-----------------------------------------------------------------------;
		CMP	[BX],AL
		JNZ	SHORT COMMAND_LOOP
;-----------------------------------------------------------------------;
;									;
;	MATCH, SET UP THE FOLLOWING REGISTERS:				;
;									;
;	BX - OFFSET TO PARAMETERS IN PARAMETER TABLE			;
;	DL - FIRST PARAMETER BYTE FROM TABLE				;
;	CX - FIRST PARAMETER OR ONE (ONE IF FIRST PARAMETER IS ZERO)	;
;									;
;-----------------------------------------------------------------------;
		MOV	AX,[BX].COM_ADDRESS
		MOV	BX,OFFSET TRANS_BUFF
		INC	BX
		ADD	BX,[DS:TABLE_OFFSET]
		MOV	DL,[BX]
		XOR	DH,DH
		MOV	CX,DX
		OR	CX,CX
		JNZ	SHORT GO_COMMAND
		INC	CX
GO_COMMAND	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GO TO THE CORRECT COMMAND SECTION				;
;									;
;-----------------------------------------------------------------------;
		JMP	AX
OUTPUT_THREE	ENDP			;END OF OUTPUT PROCEDURE NUMBER THREE
		%OUT	OUTPUT_FOUR
		PAGE
;-----------------------------------------------------------------------;
;									;
;	OUTPUT PROCEDURE FOUR						;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   AL		CHARACTER TO BE OUTPUT		;
;									;
;	ON RETURN:							;
;									;
;			THIS PROCEDURE WILL CHECK TO SEE IF THE 	;
;			CHARACTER IS AN ESCAPE CHARACTER, IF NOT	;
;			THEN THE CHARACTER WILL BE DISPLAYED ON 	;
;			THE CRT SCREEN. IF THE CHARACTER IS AN		;
;			ESCAPE CHARACTER THEN THE NEW OUTPUT		;
;			ADDRESS IS SET TO OUTPUT PROCEDURE ONE		;
;			AND THE ESCAPE CHARACTER IS NOT DISPLAYED.	;
;									;
;-----------------------------------------------------------------------;
OUTPUT_FOUR	PROC	NEAR		;OUTPUT PROCEDURE NUMBER FOUR
;-----------------------------------------------------------------------;
;									;
;	CHECK FOR AN ESCAPE CHARACTER, SET OUTPUT AS OUTPUT_ONE IF SO	;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,ESC
		JNZ	SHORT DO_OUTPUT
		MOV	WORD PTR [SI],OFFSET OUTPUT_ONE
		RET
DO_OUTPUT	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	NOT AN ESCAPE CHARACTER, GO DISPLAY THE CHARACTER THEN RETURN	;
;									;
;-----------------------------------------------------------------------;
		CALL	SHORT ACTUAL_OUTPUT
DO_RETURN	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	RESET OUTPUT ROUTINE ADDRESS AS OUTPUT_FOUR AND RETURN		;
;									;
;-----------------------------------------------------------------------;
		MOV	[DS:OUTPUT_ADDRESS],OFFSET OUTPUT_FOUR
		RET
OUTPUT_FOUR	ENDP			;END OF OUTPUT_FOUR PROCEDURE
		%OUT	FINISH
		PAGE
;-----------------------------------------------------------------------;
;									;
;	FINISH PROCEDURE						;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;	(FIN1)		--------		--------		;
;									;
;			   AH		MAXIMUM/MINIMUM LIMIT VALUE	;
;			   AL		INCREMENT VALUE 		;
;									;
;	ON ENTRY:							;
;	(FIN2)								;
;			THIS IS WHERE A COMMAND WILL COME TO FINISH	;
;			UP.						;
;									;
;	ON RETURN:							;
;									;
;			THE CURSOR WILL BE REPOSITIONED TO THE NEWLY	;
;			UPDATED POSITION AND THE CURRENT OUTPUT ADDR-	;
;			ESS WILL BE SET TO OUTPUT PROCEDURE FOUR.	;
;									;
;-----------------------------------------------------------------------;
FINISH		PROC	NEAR		;FINISH PROCEDURE
FINISH_ONE	LABEL	NEAR		;COMMAND FINISHED ROUTINE NUMBER ONE
;-----------------------------------------------------------------------;
;									;
;	CHECK VALUE TO SUPPLIED LIMIT (JUMP IF AT LIMIT TO REPOSITION)	;
;									;
;-----------------------------------------------------------------------;
		CMP	[BX],AH
		JZ	SHORT FINISH_TWO
;-----------------------------------------------------------------------;
;									;
;	ADD IN SUPPLIED INCREMENT VALUE AND LOOP UNTIL DONE		;
;									;
;-----------------------------------------------------------------------;
		ADD	[BX],AL
		LOOP	SHORT FINISH_ONE
FINISH_TWO	LABEL	NEAR		;COMMAND FINISHED ROUTINE NUMBER TWO
;-----------------------------------------------------------------------;
;									;
;	REPOSITION THE CURSOR WITH THE UPDATED POSITION AND RETURN	;
;									;
;-----------------------------------------------------------------------;
		MOV	DX,[DS:CURSOR_POSITION]
		XOR	BX,BX
		MOV	AH,POSITION_CURSOR
		VIDEO
		JMP	SHORT DO_RETURN
FINISH		ENDP			;END OF FINISH PROCEDURE
		%OUT	COMMAND
		PAGE
;-----------------------------------------------------------------------;
;									;
;	COMMAND PROCEDURE						;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;	(COMMANDS)	--------		--------		;
;									;
;			   BX		OFFSET TO PARAMETERS IN TABLE	;
;			   DL		FIRST PARAMETER VALUE		;
;			   CX		FIRST PARAMETER VALUE OR ONE	;
;					(ONE IS DEFAULT FOR ZERO PARM.) ;
;									;
;	ON RETURN:							;
;									;
;			THE REQUESTED COMMAND WILL HAVE BEEN PERFORMED	;
;			AND THE CURSOR POSITION UPDATED IF NECESSARY.	;
;			THE INDIVIDUAL COMMANDS ARE ACTUALLY CALLED	;
;			FROM THE OUTPUT THREE PROCEDURE AND ACTUALLY	;
;			RETURN THROUGH THE FINISH PROCEDURE.		;
;									;
;-----------------------------------------------------------------------;
COMMANDS	PROC	NEAR		;COMMANDS PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	CUP ROUTINE (CURSOR POSITION)					;
;	HVP ROUTINE (HORIZONTAL AND VERTICAL POSITION)			;
;									;
;-----------------------------------------------------------------------;
CUP		LABEL	NEAR		;CURSOR POSITION ROUTINE
HVP		LABEL	NEAR		;HORIZONTAL AND VERTICAL POSITION ROUTINE
;-----------------------------------------------------------------------;
;									;
;	CHECK ROW REQUESTED AGAINST MAXIMUM (RETURN IF ABOVE)		;
;									;
;-----------------------------------------------------------------------;
		CMP	CL,NUM_ROW
		JA	SHORT FINISH_TWO
;-----------------------------------------------------------------------;
;									;
;	GET REQUESTED COLUMN AND CONVERT TO ZERO-BASED NUMBER		;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,[DS:NUM_COLUMN]
		MOV	CH,[BX+1]
		OR	CH,CH
		JZ	SHORT ZERO_COLUMN
		DEC	CH
		PAGE
ZERO_COLUMN	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	CHECK COLUMN REQUESTED AGAINST MAXIMUM (UP MAXIMUM IF ABOVE)	;
;									;
;-----------------------------------------------------------------------;
		CMP	AL,CH
		JA	SHORT COLUMN_OK
		MOV	CH,AL
COLUMN_OK	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	PUT NEW ROW IN CH, COLUMN IN CL (ZERO BASE ROW AND RETURN)	;
;									;
;-----------------------------------------------------------------------;
		XCHG	CL,CH
		DEC	CH
		MOV	[DS:CURSOR_POSITION],CX
		JMP	SHORT FINISH_TWO
;-----------------------------------------------------------------------;
;									;
;	CUF ROUTINE (CURSOR FORWARD)					;
;									;
;-----------------------------------------------------------------------;
CUF		LABEL	NEAR		;CURSOR FORWARD ROUTINE
;-----------------------------------------------------------------------;
;									;
;	LOAD AH WITH MAXIMUM COLUMN NUMBER, AL WITH PLUS ONE INC. VALUE ;
;									;
;-----------------------------------------------------------------------;
		MOV	AH,[DS:NUM_COLUMN]
		MOV	AL,PLUS
HORIZONTAL_MOVE LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	POINT BX TO COLUMN NUMBER AND GO FINISH THE COMMAND		;
;									;
;-----------------------------------------------------------------------;
		MOV	BX,OFFSET COLUMN
		JMP	SHORT FINISH_ONE
;-----------------------------------------------------------------------;
;									;
;	CUB ROUTINE (CURSOR BACKWARD)					;
;									;
;-----------------------------------------------------------------------;
CUB		LABEL	NEAR		;CURSOR BACKWARD ROUTINE
;-----------------------------------------------------------------------;
;									;
;	LOAD AH WITH ZERO (MIN.), AL WITH -1, THEN GO PERFORM THE MOVE	;
;									;
;-----------------------------------------------------------------------;
		MOV	AX,MIN_INC
		JMP	SHORT HORIZONTAL_MOVE
		PAGE
;-----------------------------------------------------------------------;
;									;
;	CUU ROUTINE (CURSOR UP) 					;
;									;
;-----------------------------------------------------------------------;
CUU		LABEL	NEAR		;CURSOR UP ROUTINE
;-----------------------------------------------------------------------;
;									;
;	LOAD AH WITH ZERO (MIN.), AL WITH -1 (INCREMENT)		;
;									;
;-----------------------------------------------------------------------;
		MOV	AX,MIN_INC
VERTICAL_MOVE	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	POINT BX TO ROW NUMBER AND GO FINISH THE COMMAND		;
;									;
;-----------------------------------------------------------------------;
		MOV	BX,OFFSET ROW
		JMP	SHORT FINISH_ONE
;-----------------------------------------------------------------------;
;									;
;	CUD ROUTINE (CURSOR DOWN)					;
;									;
;-----------------------------------------------------------------------;
CUD		LABEL	NEAR		;CURSOR DOWN ROUTINE
;-----------------------------------------------------------------------;
;									;
;	LOAD AH WITH 18H (MAX), AL WITH 1, THEN GO PERFORM THE MOVE	;
;									;
;-----------------------------------------------------------------------;
		MOV	AX,MAX_INC
		JMP	SHORT VERTICAL_MOVE
;-----------------------------------------------------------------------;
;									;
;	SCP ROUTINE (SAVE CURSOR POSITION)				;
;									;
;-----------------------------------------------------------------------;
SCP		LABEL	NEAR		;SAVE CURSOR POSITION ROUTINE
;-----------------------------------------------------------------------;
;									;
;	GET CURRENT CURSOR POSITION AND SAVE FOR LATER USE		;
;									;
;-----------------------------------------------------------------------;
		MOV	AX,[DS:CURSOR_POSITION]
		MOV	[DS:CURSOR_SAVE],AX
		JMP	SHORT FINISH_TWO
		PAGE
;-----------------------------------------------------------------------;
;									;
;	RCP ROUTINE (RESTORE CURSOR POSITION)				;
;									;
;-----------------------------------------------------------------------;
RCP		LABEL	NEAR		;RESTORE CURSOR POSITION ROUTINE
;-----------------------------------------------------------------------;
;									;
;	GET SAVED CURSOR POSITION AND RESTORE AS CURRENT POSITION	;
;									;
;-----------------------------------------------------------------------;
		MOV	AX,[DS:CURSOR_SAVE]
		MOV	[DS:CURSOR_POSITION],AX
		JMP	SHORT FINISH_TWO
;-----------------------------------------------------------------------;
;									;
;	SGR ROUTINE (SET GRAPHIC RENDITION)				;
;									;
;-----------------------------------------------------------------------;
SGR		LABEL	NEAR		;GET GRAPHICS RENDITION ROUTINE
;-----------------------------------------------------------------------;
;									;
;	ZERO CURRENT PARAMETER COUNT AND GET FIRST PARAMETER ADDRESS	;
;									;
;-----------------------------------------------------------------------;
		XOR	CX,CX
		XCHG	[DS:PARM_COUNT],CL
		CALL	SHORT PARM_ADDRESS
		INC	CX
GRAPHICS_LOOP	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET A PARAMETER FROM TABLE, SAVE POINTER, AND POINT TO REN. TAB.;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,[BX]
		PUSH	BX
		MOV	BX,OFFSET RENDITION_TABLE
TABLE_LOOP	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET AN ENTRY FROM RENDITION TABLE AND CHECK FOR END-OF-TABLE	;
;									;
;-----------------------------------------------------------------------;
		MOV	AH,[BX]
		ADD	BX,REN_SIZE
		CMP	AH,EOT
		JZ	SHORT MORE_CHECK
;-----------------------------------------------------------------------;
;									;
;	NOT END-OF-TABLE, CHECK FOR A MATCH (TRY NEXT ENTRY IF NOT)	;
;									;
;-----------------------------------------------------------------------;
		CMP	AH,AL
		JNZ	SHORT TABLE_LOOP
		PAGE
;-----------------------------------------------------------------------;
;									;
;	MATCH, GET THE MASKS AND "AND" & "OR" THEM INTO CUR. ATTRIBUTE  ;
;									;
;-----------------------------------------------------------------------;
		MOV	AX,[BX-2]
		AND	[DS:ATTR],AL
		OR	[DS:ATTR],AH
MORE_CHECK	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	COME HERE TO CHECK NEXT PARAMETER ENTRY (RETURN IF NONE LEFT)	;
;									;
;-----------------------------------------------------------------------;
		POP	BX
		INC	BX
		LOOP	SHORT GRAPHICS_LOOP
		JMP	FINISH_TWO
;-----------------------------------------------------------------------;
;									;
;	ED ROUTINE (ERASE DISPLAY)					;
;									;
;-----------------------------------------------------------------------;
		PAGE
ED		LABEL	NEAR		;ERASE DISPLAY ROUTINE
;-----------------------------------------------------------------------;
;									;
;	ZERO CURRENT CURSOR POSITION AND SET WINDOW SIZE (ENTIRE SCR.)	;
;									;
;-----------------------------------------------------------------------;
		XOR	CX,CX
		MOV	[DS:CURSOR_POSITION],CX
		MOV	DH,NUM_ROW
DO_SCROLL	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET CURRENT ATTRIBUTE AND SCROLL THE DISPLAY			;
;									;
;-----------------------------------------------------------------------;
		MOV	DL,[DS:NUM_COLUMN]
		MOV	BH,[DS:ATTR]
		MOV	AX,SCROLL_WINDOW
		VIDEO
		JMP	FINISH_TWO
;-----------------------------------------------------------------------;
;									;
;	EL ROUTINE (ERASE LINE) 					;
;									;
;-----------------------------------------------------------------------;
EL		LABEL	NEAR		;ERASE LINE ROUTINE
;-----------------------------------------------------------------------;
;									;
;	GET CURRENT ROW NUMBER AND GO SCROLL PART OF THIS LINE		;
;									;
;-----------------------------------------------------------------------;
		MOV	CX,[DS:CURSOR_POSITION]
		MOV	DH,CH
		JMP	SHORT DO_SCROLL
CONVERT_ASCII	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	ROUTINE TO CONVERT A ONE BYTE BINARY NUMBER TO ONE WORD OF	;
;	DECIMAL ASCII.							;
;									;
;	ON ENTRY:	AL - CONTAINS NUMBER TO CONVERT 		:
;									;
;	ON RETURN:	AX - DECIMAL ASCII FOR ORIGINAL NUMBER IN AL	;
;									;
;-----------------------------------------------------------------------;
		MOV	DL,TEN
		INC	AL
		XOR	AH,AH
		DIV	DL
		ADD	AX,FIX
		RET
;-----------------------------------------------------------------------;
;									;
;	DSR ROUTINE (DEVICE STATUS REPORT)				;
;									;
;-----------------------------------------------------------------------;
DSR		LABEL	NEAR		;DEVICE STATUS REPORT ROUTINE
;-----------------------------------------------------------------------;
;									;
;	GET CURRENT ROW NUMBER, CONVERT IT AND STICK IT IN MESSAGE	;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,[DS:ROW]
		CALL	SHORT CONVERT_ASCII
		MOV	[DS:MSG_ROW],AX
;-----------------------------------------------------------------------;
;									;
;	GET CURRENT COLUMN NUMBER, CONVERT IT AND STICK IT IN MESSAGE	;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,[DS:COLUMN]
		CALL	SHORT CONVERT_ASCII
		MOV	[DS:MSG_COLUMN],AX
;-----------------------------------------------------------------------;
;									;
;	SET REPLACEMENT COUNTER AND POINTER TO POINT TO CPR MESSAGE	;
;									;
;-----------------------------------------------------------------------;
		MOV	[DS:REPLACE_COUNT],MSG_LENGTH
		MOV	[DS:REPLACE_PTR],OFFSET CPR_MSG
		PAGE
;-----------------------------------------------------------------------;
;									;
;	CPR ROUTINE (CURSOR POSITION REPORT)				;
;									;
;-----------------------------------------------------------------------;
CPR		LABEL	NEAR		;CURSOR POSITION REPORT ROUTINE
		JMP	DO_RETURN
;-----------------------------------------------------------------------;
;									;
;	RM ROUTINE (RESET MODE) 					;
;									;
;-----------------------------------------------------------------------;
RM		LABEL	NEAR		;RESET MODE ROUTINE
;-----------------------------------------------------------------------;
;									;
;	LOAD CL WITH ONE IN CASE OF MODE 7 RESET, THEN GO DO RESET	;
;									;
;-----------------------------------------------------------------------;
		MOV	CL,ONE
		JMP	SHORT DO_MODE
;-----------------------------------------------------------------------;
;									;
;	SM ROUTINE (SET MODE)						;
;									;
;-----------------------------------------------------------------------;
SM		LABEL	NEAR		;SET MODE ROUTINE
;-----------------------------------------------------------------------;
;									;
;	ZERO CL IN CASE OF SET MODE 7					;
;									;
;-----------------------------------------------------------------------;
		XOR	CX,CX
DO_MODE 	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET REQUESTED MODE AND CHECK AGAINST MAXIMUM (IGNORE IF ABOVE)	;
;									;
;-----------------------------------------------------------------------;
		MOV	AL,DL
		CMP	AL,MAX_MODE
		JA	SHORT CPR
		JB	SHORT REAL_MODE
;-----------------------------------------------------------------------;
;									;
;	DUMMY MODE 7 (SET/RESET THE WRAP FLAG)				;
;									;
;-----------------------------------------------------------------------;
		MOV	[DS:WRAP_FLAG],CL
		RET
		PAGE
REAL_MODE	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	SET THE REQUESTED REAL MODE					;
;									;
;-----------------------------------------------------------------------;
		MOV	AH,SET_MODE
		VIDEO
		JMP	SHORT CPR
;-----------------------------------------------------------------------;
;									;
;	KKR ROUTINE (KEYBOARD KEY REASSIGNMENT) 			;
;									;
;-----------------------------------------------------------------------;
KKR		LABEL	NEAR		;KEYBOARD KEY REASSIGNMENT ROUTINE
;-----------------------------------------------------------------------;
;									;
;	ZERO PARAMETER COUNTER AND CORRECT ACTUAL NUMBER FOR LATER USE	;
;									;
;-----------------------------------------------------------------------;
		XOR	DX,DX
		XCHG	[DS:PARM_COUNT],DL
		INC	DX
		INC	DX
		CALL	SHORT PARM_ADDRESS
;-----------------------------------------------------------------------;
;									;
;	GET REQUESTED REPLACEMENT CHARACTER AND CHECK FOR PRESENT NOW	;
;									;
;-----------------------------------------------------------------------;
		MOV	AX,[BX]
		CALL	SHORT CHECK_REPLACE
		JNZ	SHORT NOT_REPLACE
;-----------------------------------------------------------------------;
;									;
;	ENTRY ALREADY IN TABLE, WE MUST DELETE IT FIRST 		;
;									;
;-----------------------------------------------------------------------;
		MOV	DI,BX
		SUB	[DS:TABLE_OFFSET],CX
		MOV	SI,DI
		ADD	SI,CX
		MOV	CX,OFFSET TRANS_END
		SUB	CX,SI
		CLD
		PUSH	ES
		PUSH	CS
		POP	ES
;-----------------------------------------------------------------------;
;									;
;	MOVE THE ENTIRE TABLE UP TO DELETE THIS ENTRY			;
;									;
;-----------------------------------------------------------------------;
		REPZ	MOVSB
		POP	ES
		PAGE
NOT_REPLACE	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	GET ADDRESS TO STORE AND CHECK NUMBER OF PARAMETERS		;
;									;
;-----------------------------------------------------------------------;
		CALL	SHORT PARM_ADDRESS
		CMP	DL,MIN_PARM
		JB	SHORT KEY_RETURN
;-----------------------------------------------------------------------;
;									;
;	ENOUGHT PARAMETERS IN THE TABLE, ADD THIS ENTRY IN		;
;									;
;-----------------------------------------------------------------------;
		MOV	[BX-1],DL
		ADD	[DS:TABLE_OFFSET],DX
		ADD	BX,DX
KEY_RETURN	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	PUT IN END-OF-TABLE MARK & SET OUTPUT ADDRESS TO OUTPUT_FOUR	;
;									;
;-----------------------------------------------------------------------;
		MOV	BYTE PTR [BX-1],ZERO
		MOV	[DS:OUTPUT_ADDRESS],OFFSET OUTPUT_FOUR
		RET
COMMANDS	ENDP			;END OF COMMANDS PROCEDURE
		%OUT	PARM_ADDRESS
		PAGE
;-----------------------------------------------------------------------;
;									;
;	COMPUTE PARAMETER STORAGE ADDRESS PROCEDURE			;
;									;
;	ON ENTRY:							;
;									;
;			THIS PROCEDURE IS CALLED TO FIND THE NEXT	;
;			AVAILABLE ADDRESS TO STORE A PARAMETER		;
;			BYTE INTO THE PARAMETER TABLE.			;
;									;
;	ON RETURN:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   BX		OFFSET OF PARAM. STORAGE ADDR.	;
;									;
;	NOTE -	THIS ROUTINE WILL NOT ALLOW THE NUMBER OF PARAMETERS	;
;		TO EXCEED A PREDEFINED LIMIT. (200)			;
;									;
;-----------------------------------------------------------------------;
PARM_ADDRESS	PROC	NEAR		;GET PARAMETER ADDRESS PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	GET PARAMETER TABLE OFFSET AND CORRECT				;
;									;
;-----------------------------------------------------------------------;
		MOV	BX,[DS:TABLE_OFFSET]
		INC	BX
;-----------------------------------------------------------------------;
;									;
;	ADD IN CURRENT COUNTER AND CHECK AGAINST MAX. (DON'T EXCEED IT) ;
;									;
;-----------------------------------------------------------------------;
		ADD	BX,[DS:PARM_CNT]
		CMP	BX,PARM_MAX
		JB	SHORT PARM_RETURN
		DEC	[DS:PARM_COUNT]
		JMP	SHORT PARM_ADDRESS
PARM_RETURN	LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	ADD IN OFFSET TO TRANSLATION BUFFER AND RETURN ADDRESS		;
;									;
;-----------------------------------------------------------------------;
		ADD	BX,OFFSET TRANS_BUFF
		RET
PARM_ADDRESS	ENDP			;END OF PARM_ADDRESS PROCEDURE
		%OUT	TRANSLATION BUFFER AREA
		PAGE
;-----------------------------------------------------------------------;
;									;
;	TRANSLATION TABLE BUFFER AREA					;
;									;
;-----------------------------------------------------------------------;
TRANS_BUFF	LABEL	NEAR		;TRANSLATION BUFFER AREA
		EXTENT	<04H,00H,72H,10H>
TRANS_START	LABEL	NEAR		;FIRST AVAILABLE TABLE ENTRY
		DB	0C4H DUP (0)	;DEFINE REST OF TRANSLATION BUFFER
TRANS_END	LABEL	NEAR		;END OF THE TRANSLATION BUFFER
		%OUT	INITIAL
		PAGE
;-----------------------------------------------------------------------;
;									;
;	INITIALIZATION PROCEDURE					;
;									;
;	ON ENTRY:	REGISTER		CONTENTS		;
;			--------		--------		;
;									;
;			   DS		REQUEST HEADER SEG. POINTER	;
;			   BX		REQUEST HEADER OFF. POINTER	;
;									;
;	ON RETURN:							;
;									;
;			THIS PROCEDURE WILL FIRST SET UP THE CORRECT	;
;			SCREEN MEMORY ADDRESS FOR EITHER THE COLOR	;
;			OR MONOCHROME SCREEN. NEXT THE PROCEDURE WILL	;
;			SET UP THE INTERRUPT VECTORS FOR INTERRUPTS	;
;			1BH (CTRL-BREAK) AND 29H (INTERNAL DOS PRINT).	;
;			THE LAST TWO THINGS THIS PROCEDURE DOES IS	;
;			TO SET THE ENDING ADDRESS IN THE REQUEST	;
;			HEADER ALONG WITH THE STATUS WORD, AND THEN	;
;			RETURN. 					;
;									;
;-----------------------------------------------------------------------;
INITIAL 	PROC	NEAR		;INITIALIZATION PROCEDURE
;-----------------------------------------------------------------------;
;									;
;	DO EQUIPMENT CHECK AND GET THE TYPE OF MONITOR AND MODE 	;
;									;
;-----------------------------------------------------------------------;
		EQUIP
		AND	AL,VIDEO_MASK
		CMP	AL,MONO_BITS
		JNZ	SHORT NOT_A_MONO
		MOV	[DS:SCREEN_ADDRESS],MONO_CHROME
NOT_A_MONO	LABEL	NEAR
		CMP	AL,FORTY
		JA	SHORT EIGHTY
		MOV	[DS:CURR_MODE],ZERO
		MOV	[DS:NUM_COLUMN],HALF
EIGHTY		LABEL	NEAR
;-----------------------------------------------------------------------;
;									;
;	SET UP THE INTERRUPT VECTORS					;
;									;
;-----------------------------------------------------------------------;
		XOR	BX,BX
		MOV	DS,BX
		MOV	BX,VECTOR_1B
		MOV	WORD PTR [BX],OFFSET CTRL_BREAK
		MOV	[BX+2],CS
		MOV	BX,VECTOR_29
		MOV	WORD PTR [BX],OFFSET INT_29
		MOV	[BX+2],CS
		PAGE
;-----------------------------------------------------------------------;
;									;
;	SET ENDING ADDRESS IN REQUEST HEADER AND RETURN 		;
;									;
;-----------------------------------------------------------------------;
		LDS	BX,DWORD PTR [CS:HEADER_OFFSET]
		MOV	WORD PTR [BX+0EH],OFFSET INITIAL
		MOV	[BX+10H],CS
		JMP	OK_RETURN
INITIAL 	ENDP			;END OF INIT PROCEDURE
		PAGE
;-----------------------------------------------------------------------;
;									;
;	BYTES TO EVEN OUT THE FILE SIZE 				;
;									;
;-----------------------------------------------------------------------;
		DB	33H DUP (0)	;MAKE FILE SIZES MATCH (EVEN FILE LENGTH)
CODE		ENDS			;END OF CODE SEGMENT
		END			;END OF ANSI.SYS
